const fs = require('fs').promises;
const path = require('path');
const process = require('process');
const { authenticate } = require('@google-cloud/local-auth');
const { google } = require('googleapis');
const express = require('express')
const app = express()
const port = 3000
var spreadsheetId = "1GaCF2NejkzxKD0Eu9f-SDN1IQCShMCoLQs2w9i2huSs";
const SCOPES = ['https://www.googleapis.com/auth/spreadsheets.readonly'];
const TOKEN_PATH = path.join(process.cwd(), 'token.json');
const CREDENTIALS_PATH = path.join(process.cwd(), 'credentials.json');
var auth = null;
/**
 * Reads previously authorized credentials from the save file.
 * @return {Promise<OAuth2Client|null>}
 */
async function loadSavedCredentialsIfExist() {
    try {
        const content = await fs.readFile(TOKEN_PATH);
        const credentials = JSON.parse(content);
        return google.auth.fromJSON(credentials);
    } catch (err) {
        return null;
    }
}
/**
 * Serializes credentials to a file comptible with GoogleAUth.fromJSON.
 * @param {OAuth2Client} client
 * @return {Promise<void>}
 */
async function saveCredentials(client) {
    const content = await fs.readFile(CREDENTIALS_PATH);
    const keys = JSON.parse(content);
    const key = keys.installed || keys.web;
    const payload = JSON.stringify({
        type: 'authorized_user',
        client_id: key.client_id,
        client_secret: key.client_secret,
        refresh_token: client.credentials.refresh_token,
    });
    await fs.writeFile(TOKEN_PATH, payload);
}
/**
 * Load or request or authorization to call APIs.
 */
async function authorize() {
    let client = await loadSavedCredentialsIfExist();
    if (client) {
        return client;
    }
    client = await authenticate({
        scopes: SCOPES,
        keyfilePath: CREDENTIALS_PATH,
    });
    if (client.credentials) {
        await saveCredentials(client);
    }
    return client;
}
async function getdata(auth, sheettap, range) { 
    const sheets = google.sheets({ version: 'v4', auth });
    const res = await sheets.spreadsheets.values.get({
        spreadsheetId: spreadsheetId,
        range: sheettap + '!' + range,
    });
    return res.data.values;
}


/* Route All API START */

// params [key] = id ผล
app.get('/', async (req, res) => {
    var resp = "";
    if (req.query.key !== null  && req.query.key !== "" && req.query.key !== undefined) {
        resp = await getdata(this.auth, 'Sheet1', 'A2:H115'); // ดึงมาทั้งก้อน
        var start_key = 2; // แถวเริ่มต้น
        resp.forEach(async key =>  {
            if (key[0] == req.query.key) { // check string == string
                resp = {
                    "key": key[0],
                    "icon": key[1],
                    "time": key[2],
                    "name": key[3],
                    "theme1": key[5],
                    "theme2": key[7]
                };
            }
            start_key++;
        });
    }
    res.json(resp)
})




/* Route All API END */






app.listen(port, async () => {
     this.auth = await authorize();
    console.log(`Example app listening on port ${port}`)
})